/// Settings
/// 
/// Hier werden die Einstellungen des VDRs in eine entsprechende Datenstruktur gekapselt.
/// Weiterhin sind hier die Lade- und Speicher-Methoden der Einstellungen untergebracht.
/// 
///  20.12.2004	-	initial Release		-	Daniel Kirstenpfad
/// 
namespace VDRGUI
{
	using System;
	//using Settings;	// Einstellungen-Datenstruktur

	/// <summary>
	/// Hier werden die Einstellungen des VDRs in eine entsprechende Datenstruktur gekapselt.
	/// Weiterhin sind hier die Lade- und Speicher-Methoden der Einstellungen untergebracht.
	/// </summary>
	public class SettingsProcessor
	{

		private Settings VDRGUI_Settings = new Settings();		// leere Datenstruktur erzeugen
		
		/// <summary>
		/// Konstruktor; idealerweise wird hier sofort versucht die Einstellungen aus der XML Datei zu laden, andernfalls
		/// wird die Settings-Datenstruktur nur initialisiert
		/// </summary>
 		public SettingsProcessor()
		{
			try
			{
				VDRGUI_Settings.ReadXml("vdrgui_settings.xml");
			}
			catch (Exception e)
			{
					Console.WriteLine(e.Message);
			}
		}



		// Schnittstelle in andere Programmteile damit diese uneingeschrnkten Zugriff auf die Einstellungen haben
		public Settings exchangeSettings
		{
			get
			{
				return VDRGUI_Settings;
			}
			set
			{
				VDRGUI_Settings = value;
			}
		}

		public void SaveSettings()
		{
			VDRGUI_Settings.WriteXml("vdrgui_settings.xml");
		}	


	}
}
