/// TODO: Variablen-Namen einheitlich benennen, Englisch 
/// TODO: Methoden-Namen einheitlich benennen, Englisch

using System;
using System.Threading;

namespace VDRGUI
{
	/// <summary>
	/// Setup Backend	
	/// </summary>
	class backend
	{
		#region Variables
		public static bool verbose;
		public static int port = 100;
		public static string docRoot = ".";
		public static ParserAndData epgDaten = null;
		public static bool quit = false;
		public static System.Data.DataTable Aufzeichungen = new System.Data.DataTable();
		#endregion

	}
	/// <summary>
	/// GUI Frontend Klasse
	/// </summary>
	class frontend
	{
		#region Parameter and Usage
		private static void usage() 
		{
			Console.WriteLine("Usage: httpd [-port port] [-docroot path] [-verbose] [/?]");
		}

		public static int check_parameters(String[] parameter) 
		{
			for(int i = 0; i < parameter.Length; i++)
			{
				switch(parameter[i])
				{
					case "/?":
						usage();
						return 1;
					case "-port":
						if (i < parameter.Length - 1) 
						{
							backend.port = int.Parse(parameter[++i]);
						} 
						else 
						{
							usage();
						}
						break;
					case "-docroot":
						if (i < parameter.Length - 1) 
						{
							backend.docRoot = parameter[++i];
						} 
						else 
						{
							usage();
						}
						break;
					case "-verbose":
						backend.verbose = true;
						break;
					default:
						usage();
						return 1;
				}
			}
			return 0;
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			#region Funktions-Tests
			#region epgParser Test

			check_parameters(args);
			backend.epgDaten = new ParserAndData("c:\\epg3.data");
			backend.epgDaten.parse_EPG();

			//Console.Write(backend.epgDaten.getXMLEPG());
			//	backend.epgDaten.DEMO_OutputData();
			#endregion

			#region Settings Laden+Speichern
	/*		SettingsProcessor Einstellungen = new SettingsProcessor();
			Settings EinstellungsDatenstruktur = Einstellungen.exchangeSettings;
			Einstellungen.exchangeSettings = EinstellungsDatenstruktur;
			Einstellungen.SaveSettings();*/
			#endregion

			#region SVDRPClient Text

			SVDRPClient VDRServer = new SVDRPClient("localhost",2001);

			string temp = VDRServer.connect();

			Console.WriteLine(temp);

			temp = VDRServer.LSTR();

			Console.WriteLine(temp);
			
			backend.epgDaten.parse_LSTR(temp);

			temp = VDRServer.QUIT();

			Console.WriteLine(temp);
			#endregion
			#endregion

			/// die eigentliche WebApplikation - wird vom Webserver bentigt um Anfragen zu bearbeiten
			#region WebApplication Processor
			WebApplication WebApplikation = new WebApplication(backend.epgDaten.GetherData());
			#endregion

			/// der eigentliche Webserver
			#region HTTPServer
			HttpServer httpServer;
			httpServer = new HttpServer(backend.docRoot,backend.port,WebApplikation);
			Thread thread = new Thread(new ThreadStart(httpServer.listen));
			thread.Start();
			#endregion

			/// Erledigt alle zeitabhngigen Aufgaben
			/// z.B. EPG Updates, Programm-Ende, Timer-Synchronisation
			#region Frontend Management Thread
			Console.WriteLine("STRG+C um das Programm zu beenden.");
			int ticks = 0;
			while(!backend.quit)
			{
				Thread.Sleep(1000);
				ticks++;
				if (ticks == 60)		// 1m
				{
						/// TODO: hier werden die EPG Daten neu eingelesen - es muss dafr aber eine Sync Methode her und vor allem muss verhindert werden das eine andere Methode gerade auf dei EPG Daten zugreift
						backend.epgDaten.parse_EPG();
				}
				Console.Write(".");
			}
			#endregion
		}
	}
}
