using System;
using System.Text;
using System.Data;

namespace VDRGUI
{
/// <summary>
/// Hier werden die eigentlichen HTML Quelltexte generiert - also die Templates interpretiert, verndert
/// und an den User geschickt
/// </summary>
	public class WebApplication
	{
		private EPGData VDR_Daten;

		/// <summary>
		/// Konstruktor der WebApplication Klasse
		/// </summary>
		/// <param name="Data">die initialisierte EPG Daten-Klasse</param>
		public WebApplication(EPGData Data)
		{
			VDR_Daten = Data;
		}

		/// <summary>
		/// Bearbeitet die HTTP Useranfrage und erzeugt die HTML Seiten die der User angezeigt bekommt
		/// </summary>
		/// <param name="UserRequest">Request des Users</param>
		/// <returns>HTML Quelltext-Antwort fr den User</returns>
		public string process_request(string UserRequest)
		{
			string HTMLSource = "";

			// HTML Generator Objekt erzeugen
			WebApplicationHTMLGenerator HTMLProcessor = new WebApplicationHTMLGenerator(VDR_Daten);

			// ersten Slash entfernen
			if (UserRequest.StartsWith("/")) 
				UserRequest = UserRequest.Remove(0,1);
			string[] splittet = UserRequest.Split(' ');

			if (splittet.Length > 1)
			{
				switch(splittet[0])
				{
						#region WhatsonTV WebApplication Call
						case "whatsontv":
						Console.WriteLine("Web-Application: Whats-On-Tv\n");
						// berprfen ob noch weitere Parameter bergeben worden sind (bspw. Senderkennung)
						HTMLSource = HTMLProcessor.WhatsOnTvNow();
						
						break;
						#endregion
				}
			}
			else
			{
				#region Root Request WebApplication Call
				// offensichtlich handelt es sich um die Root-Anforderung
				Console.WriteLine("Web-Application: Root Request\n");
				HTMLSource = HTMLProcessor.RootRequest();
				#endregion
			}
			return HTMLSource;
		}
	}
}
